﻿Public Class Form1
    Private Sub frmDragRichText_Load() Handles MyBase.Load
        ' Give the RichTextBox some text.
        Dim txt As String = "The quick brown fox jumps over the lazy dog."
        rchSource.Text = txt

        rchSource.Select(txt.IndexOf("quick"), Len("quick"))
        rchSource.SelectionFont = New Font(rchSource.SelectionFont, FontStyle.Italic)

        rchSource.Select(txt.IndexOf("brown"), Len("brown"))
        rchSource.SelectionFont = New Font(rchSource.SelectionFont, FontStyle.Bold)
        rchSource.SelectionColor = Color.Brown

        rchSource.Select(txt.IndexOf("fox"), Len("fox"))
        rchSource.SelectionFont = New Font(rchSource.SelectionFont, FontStyle.Bold)
        rchSource.SelectionColor = Color.Red

        rchSource.Select(txt.IndexOf("jumps over"), Len("jumps over"))
        rchSource.SelectionFont = New Font(rchSource.SelectionFont, FontStyle.Underline)

        rchSource.Select(txt.IndexOf("lazy"), Len("lazy"))
        rchSource.SelectionFont = New Font(rchSource.SelectionFont, FontStyle.Bold)

        rchSource.Select(txt.IndexOf("dog"), Len("dog"))
        rchSource.SelectionFont = New Font(rchSource.SelectionFont, FontStyle.Bold)
        rchSource.SelectionColor = Color.Blue

        rchSource.Select(0, 0)
    End Sub

    ' Start a drag.
    Private Sub lblDragSource_MouseDown() Handles lblDragSource.MouseDown
        ' Make a DataObject.
        Dim data_object As New DataObject

        ' Add the data in various formats.
        data_object.SetData(DataFormats.Rtf, rchSource.Rtf)
        data_object.SetData(DataFormats.Text, rchSource.Text)

        ' Build the HTML version.
        Dim html_text As String
        html_text = "<HTML>" & vbCrLf
        html_text &= "  <HEAD>The Quick Brown Fox</HEAD>" & vbCrLf
        html_text &= "  <BODY>" & vbCrLf
        html_text &= rchSource.Text & vbCrLf
        html_text &= "  </BODY>" & vbCrLf & "</HTML>"
        data_object.SetData(DataFormats.Html, html_text)

        ' Start the drag.
        lblDragSource.DoDragDrop(data_object, DragDropEffects.Copy)
    End Sub

    ' Allow drop of Rtf, Text, and HTML.
    Private Sub lblDropTarget_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lblDropTarget.DragEnter
        If e.Data.GetDataPresent(DataFormats.Rtf) Or
           e.Data.GetDataPresent(DataFormats.Text) Or
           e.Data.GetDataPresent(DataFormats.Html) _
        Then
            e.Effect = DragDropEffects.Copy
        End If
    End Sub

    ' Display whatever data we can.
    Private Sub lblDropTarget_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lblDropTarget.DragDrop
        If e.Data.GetDataPresent(DataFormats.Rtf) Then
            rchTarget.Rtf = e.Data.GetData(DataFormats.Rtf).ToString
            lblRtf.Text = e.Data.GetData(DataFormats.Rtf).ToString
        Else
            rchTarget.Text = ""
            lblRtf.Text = ""
        End If

        If e.Data.GetDataPresent(DataFormats.Text) Then
            lblTarget.Text = e.Data.GetData(DataFormats.Text).ToString
        Else
            lblTarget.Text = ""
        End If

        If e.Data.GetDataPresent(DataFormats.Html) Then
            lblHtml.Text = e.Data.GetData(DataFormats.Html).ToString
        Else
            lblHtml.Text = ""
        End If
    End Sub
End Class
